addHook("PreThinkFrame", function()
	for player in players.iterate()
        -- Validitycheck
        if not (
			A_KRCheckExistence(player)
			and player.playerstate == PST_LIVE
			and player.mo.skin == "sonic"
		)
            continue
        end
		
		if player.charability != CA_NONE
			if (player.powers[pw_super] and not player.krework.superpowers)
				player.charability = CA_THOK
			else
				player.charability = CA_DOUBLEJUMP
			end
		end
		
		local mo = player.mo
		
		-- Dust trail to show Sonic's double-jump isn't available
		if mo.krework.sonic.dbljumped
		and leveltime % 7 == 0
			local r = mo.radius/FRACUNIT
			local randx = (P_RandomKey(r+1) - r/2) * FRACUNIT
			local randy = (P_RandomKey(r+1) - r/2) * FRACUNIT
			local dust = P_SpawnMobjFromMobj(mo, randx, randy, mo.height/2, MT_SPINDUST)
		end
	end
end)

addHook("PlayerThink", function(player)
	-- Validity check
	if not (
		A_KRCheckExistence(player)
		and player.playerstate == PST_LIVE
		and player.mo.skin == "sonic"
	)
		return
	end
	
	local mo = player.mo
	local charge = mo.krework.sonic.dropcharge
	local superpow = player.krework.superpowers
	
	-- Release drop dash if you hit the ground while charged
	if mo.eflags & MFE_JUSTHITFLOOR
	and charge > 0
	and not (mo.eflags & MFE_SPRUNG)
	and not (mo.state == S_PLAY_SPINDASH)
		A_KRReleaseDropDash(player)
		
	-- Otherwise check conditions for charging dropdash
	-- Have to be off the ground to charge
	elseif not P_IsObjectOnGround(player.mo)
	-- Have to be in a jumping state to charge
	and (player.pflags & PF_JUMPED)
	-- Have to have control to charge
	and not A_KRCheckNoControl(player) and (player.cmd.buttons & BT_USE)
	-- Dropdash has to start with a button press, not a hold
	and (not (player.krework.pbuttons & BT_USE) or charge > 0)
	-- Can't dropdash if Super Sonic's ability changes are turned off
	and not (player.powers[pw_super] and not superpow)
		A_KRChargeDropDash(player)
	
	-- If charge conditions aren't met, discharge the dropdash
	else
		mo.krework.sonic.dropcharge = 0
		if mo.state == S_DROPDASH1
			mo.state = S_PLAY_JUMP
		end
	end
end)

addHook("AbilitySpecial", A_KRSonicDoubleJump)
